// this is O(total number of pions)! 
static Pion *pion_with_pos(Game *game, HexPos pos) {
	Pion *pion, *end;
	for (pion = game->pions, end = pion + game->npions; pion != end; ++pion) {
		if (hex_eq(pion->pos, pos))
			return pion;
	}
	return NULL;
}
static Pion *pion_with_new_pos(Game *game, HexPos pos) {
	Pion *pion, *end;
	for (pion = game->pions, end = pion + game->npions; pion != end; ++pion) {
		if (hex_eq(pion->new_pos, pos))
			return pion;
	}
	return NULL;
}

// set m's new position to m's position, and force any other necessary pions back too 
static void pion_force_move_back(Game *game, Pion *p) {
	// find any other pion planning to move here 
	Pion *other = pion_with_new_pos(game, p->pos); // @OPTIM 
	p->new_pos = p->pos;
	if (other) {
		// force the other pion to move back 
		pion_force_move_back(game, other);
	}
}

static void pion_remove(Game *game, Pion *p) {
	assert(p);
	if (--game->npions)
		*p = game->pions[game->npions];
}

// remove pion at pos if there is one there 
static void pion_remove_at_pos(Game *game, HexPos pos) {
	Pion *pion = pion_with_pos(game, pos);
	if (pion) pion_remove(game, pion);
}
